// BWDocument-Undo -- category on BWStitchNoteDocument to handle all the
//                    undo jazz

#import "BWStitchNoteDocument.h"
#import "BWStitchGroup.h"

@interface BWStitchNoteDocument(UndoStuff)

// stash away model settings that are controlled by continuous controls
- (void) rememberUndoInformation;

- (void) setupUndo;
- (void) deallocUndo;

- (void) addStitchLocation: (BWStitchLocation) location;
- (void) removeLastStitchLocation;

- (void) setFabricWidth: (float) width;
- (void) enqueueFabricWidthChange: (id) sender;

- (void) setFabricSpacing: (float) spacing;
- (void) enqueueFabricSpacingChange: (id) sender;

- (void) setStitchSize: (float) width;
- (void) enqueueStitchSizeChange: (id) sender;

- (void) setFabricColor: (NSColor *) color;
- (void) enqueueFabricColorChange: (id) sender;

- (void) setBackgroundColor: (NSColor *) color;
- (void) enqueueBackgroundColorChange: (id) sender;

- (void) setStitchColor: (NSColor *) color;
- (void) enqueueStitchColorChange: (id) sender;

- (void) setTextColor: (NSColor *) color;
- (void) enqueueTextColorChange: (id) sender;

- (void) setNumberDisplay: (BWStitchGroup_NumberDisplay) value;

- (void) setFontFamily: (NSString *) familyName  size: (int) size
		  bold: (BOOL) boldO  italic: (BOOL) italic;

- (void) shiftStitchesBy: (int) number
	       direction: (BWStitchGroup_ShiftDirection) direction;

- (void) setPrintableArea: (BWIntRect) printableArea;
- (void) clearPrintableArea;

@end // BWStitchNodeDocument(UndoStuff)

